
/******************************************************************************\
*       This is a part of the Microsoft Source Code Samples. 
*       Copyright (C) 1993-1995 Microsoft Corporation.
*       All rights reserved. 
*       This source code is only intended as a supplement to 
*       Microsoft Development Tools and/or WinHelp documentation.
*       See these sources for detailed information regarding the 
*       Microsoft samples programs.
\******************************************************************************/

#include <windows.h>
#include <string.h>

/*
 * Resource defines
 */
#define WINDOWMENU  1

#ifdef RC_INVOKED
#define ID(id) id
#else
#define ID(id) MAKEINTRESOURCE(id)
#endif

#define APPICON         1001

/*
 * Menu ID's
 */
#define MM_ABOUT        8000
#define MM_BOUNCE       8001
#define MM_SNAKE        8002
#define MM_WOBBLE       8003

#define IDM_CASCADE     30
#define IDM_TILE        31
#define IDM_ARRANGE     32
#define IDM_CLOSEALL    33

#define SIZEOFCAPTIONTEXT       20
#define CCOLORS 16
#define CPOINTS 20
#define COBJS   1


typedef struct _b {
    POINT apt[CPOINTS];
    int dx;
    int dy;
    int vx;
    int vy;
    int ax;
    int ay;
    int iColor;
} B;


typedef struct _ThreadBlockInfo {
        HANDLE  hThread;
        BOOL    bKillThrd;
        HWND    hwndClient;
        HWND    hwndThreadWindow;
        LONG    lThreadId;
        char    CaptionBarText[SIZEOFCAPTIONTEXT];
        B       gab[COBJS];
        RECT    rcClient;
        HDC     hdcThreadWindow;
} THREADBLOCKINFO, *PTHREADBLOCKINFO;


typedef struct _node {
    THREADBLOCKINFO ThreadWindow;
    HANDLE          hNext;
} NODE, *PNODE;
//______________________________________/\________________________________________
extern HANDLE ghModule;
extern HWND   ghwndMain ;
extern HBRUSH ghbrWhite, ghbrBlack;
extern HBRUSH gahbrColor[CCOLORS];
extern int    cmdDemo ;
extern BOOL   bKillMe ;
extern DWORD aclr[CCOLORS] ;
extern HMENU  hMenu, hMenuWindow;

//______________________________________/\________________________________________
/*
 * Forward declarations.
 */
BOOL InitializeApp   (void);
int WINAPI MainWndProc     (HWND, UINT, DWORD, LONG);
int WINAPI ThreadWndProc   (HWND, UINT, DWORD, LONG);
int WINAPI About                 (HWND, UINT, DWORD, LONG);
LONG StartBounce     (PTHREADBLOCKINFO);
void DrawBox         (int, int, HBRUSH, PTHREADBLOCKINFO);
void MoveBox         (int *px, int *py, int *pdx, int *pdy, int *pvx, int *pvy, int ax, int ay, PTHREADBLOCKINFO pThreadBlockInfo);
void BounceProc      (PTHREADBLOCKINFO);
BOOL StartDemo       (int, PTHREADBLOCKINFO);
int  GetRandomVector ();
void InitializeBoxes (BOOL, PTHREADBLOCKINFO);
